/*
 * DAC_sinus.c
 *
 *  Created on: 25.03.2013
 *      Author: DL9MWE
 */

#include	"main.h"


// Sinus-Tabelle; stellt eine 4tel Schwingung dar
static const unsigned int sinus_tabelle[33] =
{ 0,97,195,291,388,483,577,670,761,851,938,1024,1107,1188,1266,1341,1413,1482,
1548,1610,1668,1723,1774,1820,1863,1901,1935,1965,1990,2011,2027,2039,2046 };



// Sinus aus Tabelle ausgeben
void DAC_sinus(unsigned int qrg) {
  unsigned int error_code;
  int stuetzstelle;

	for(stuetzstelle=0; stuetzstelle <= 31; ++stuetzstelle) {	// 1. Quadrant
		MCP4726_setDAC_value(sinus_tabelle[stuetzstelle] + MAX_DAC_VALUE/2, &error_code);
	}
	for(stuetzstelle=32; stuetzstelle > 0; --stuetzstelle) {	// 2. Quadrant
		MCP4726_setDAC_value(sinus_tabelle[stuetzstelle] + MAX_DAC_VALUE/2, &error_code);
	}
	for(stuetzstelle=0; stuetzstelle <= 31; ++stuetzstelle) {	// 3. Quadrant
		MCP4726_setDAC_value(MAX_DAC_VALUE/2 - sinus_tabelle[stuetzstelle], &error_code);
	}
	for(stuetzstelle=32; stuetzstelle > 0; --stuetzstelle) {	// 4. Quadrant
		MCP4726_setDAC_value(MAX_DAC_VALUE/2 - sinus_tabelle[stuetzstelle], &error_code);
	}
}

void DAC_sinuscontinuous(unsigned int qrg) {
  unsigned int error_code;
  int stuetzstelle;

	for(stuetzstelle=0; stuetzstelle <= 31; ++stuetzstelle) {	// 1. Quadrant
		MCP4726_continuousDAC_value(sinus_tabelle[stuetzstelle] + MAX_DAC_VALUE/2, &error_code);
	}
	for(stuetzstelle=32; stuetzstelle > 0; --stuetzstelle) {	// 2. Quadrant
		MCP4726_continuousDAC_value(sinus_tabelle[stuetzstelle] + MAX_DAC_VALUE/2, &error_code);
	}
	for(stuetzstelle=0; stuetzstelle <= 31; ++stuetzstelle) {	// 3. Quadrant
		MCP4726_continuousDAC_value(MAX_DAC_VALUE/2 - sinus_tabelle[stuetzstelle], &error_code);
	}
	for(stuetzstelle=32; stuetzstelle > 0; --stuetzstelle) {	// 4. Quadrant
		MCP4726_continuousDAC_value(MAX_DAC_VALUE/2 - sinus_tabelle[stuetzstelle], &error_code);
	}
}

// Ende DAC_sinus.c
