/*
 * LCD.h
 *
 *  Created on: 25.07.2012
 *      Author: Gerrit
 */

#ifndef LCD_H_
#define LCD_H_


// ************* prototypes ******************
void vSendByteToLCD_4BIT(unsigned char, unsigned char);
void vSendByteToLCD_8BIT(unsigned char);
void vLCD_init(unsigned char);
void vLCD_delay(void);
void vLCD_clear(void);
void vLCD_gotoxy( unsigned char , unsigned char);
void vLCD_putchar(unsigned char);
void vLCD_puts(char *);
void vLCD_putui(unsigned int);
void vLCD_puti(int);

#define LCD_DATA_OUT              P2OUT
#define LCD_DATA_DIR              P2DIR
#define LCD_COMM_OUT              P1OUT
#define LCD_COMM_DIR              P1DIR
#define DATA_LINE_BITMASK    	( 0x0F )                       // LCD D7 - D4
#define CONTROL_LINE_BITMASK 	( 0x30 )                       // bit4 -> RS | bit5 -> E
#define ENABLE_BIT           	( 0x20 )                       // Enable Display
#define RS_BIT               	( 0x10 )                       // Register Select Display
#define SELECT_COMMAND_REG   LCD_COMM_OUT &= ~RS_BIT          // set RS to low
#define SELECT_DATA_REG      LCD_COMM_OUT |=  RS_BIT          // set RS high

// Read-mode wird bis auf weiteres nicht verwendet
//#define DISPLAY_WRITE        LCD_COMM_OUT &= ~RW_BIT        // write to display (low)
//#define DISPLAY_READ         LCD_COMM_OUT |=  RW_BIT        // read from display (high)

// "Taktleitung" des LCD
#define DISPLAY_ENABLE_HIGH  LCD_COMM_OUT |=  ENABLE_BIT      // enable HIGH
#define DISPLAY_ENABLE_LOW   LCD_COMM_OUT &= ~ENABLE_BIT      // enable LOW
#define COMMAND      0
#define DATA         1


#endif /* LCD_H_ */
