/*
 * MCP4726.c
 *
 *  Created on: 24.03.2013
 *      Author: DL9MWE
 */
#include	"main.h"


// DAC-Wert an MCP4726 senden
//	endet mit STOP-Condition
void MCP4726_setDAC_value(unsigned int value, unsigned int* error_code) {
//	vLCD_puts(" = "); vLCD_putui(value); vLCD_puts("  ");

	MSP430_SWI2CMST_start();						//Send I2C Start Condition
	MSP430_SWI2CMST_txByte(MCP4726_I2C_Address);	// [ADDR] + R/W bit = 0
	*error_code = MSP430_SWI2CSLV_ack();			// get slave acknowledge (ACKS)
	MSP430_SWI2CMST_txByte(MCP4726_Write_Volatile_Memory<<5 | MCP4726_REF_VOLTAGE<<3 | MCP4726_POWER_DOWN<<1);	// Command Byte
	*error_code += MSP430_SWI2CSLV_ack();			// get ACKS
	MSP430_SWI2CMST_txByte((unsigned char)(value>>4 & 0xff));	// send Databits 11 bis 04
	*error_code += MSP430_SWI2CSLV_ack();			// get ACKS
	MSP430_SWI2CMST_txByte((unsigned char)(value<<4 & 0xff));	// send Databits 03 bis 00
	*error_code += MSP430_SWI2CSLV_ack();			// get ACKS
	MSP430_SWI2CMST_stop();							//Send I2C Stop Condition
}

// DAC-Wert an MCP4726 senden
//	endet mit REPEATED-START-Condition
volatile unsigned int first=1;
void MCP4726_continuousDAC_value(unsigned int value, unsigned int* error_code) {
	if(first == 1) {
		MSP430_SWI2CMST_start();						//Send I2C Start Condition
		first = 0;
	}
	MSP430_SWI2CMST_txByte(MCP4726_I2C_Address);	// [ADDR] + R/W bit = 0
	*error_code = MSP430_SWI2CSLV_ack();			// get slave acknowledge (ACKS)
	MSP430_SWI2CMST_txByte(MCP4726_Write_Volatile_Memory<<5 | MCP4726_REF_VOLTAGE<<3 | MCP4726_POWER_DOWN<<1);	// Command Byte
	*error_code = MSP430_SWI2CSLV_ack();			// get ACKS
	MSP430_SWI2CMST_txByte((unsigned char)(value>>4 & 0xff));	// send Databits 11 bis 04
	*error_code += MSP430_SWI2CSLV_ack();			// get ACKS
	MSP430_SWI2CMST_txByte((unsigned char)(value<<4 & 0xff));	// send Databits 03 bis 00
	*error_code += MSP430_SWI2CSLV_ack();			// get ACKS
	MSP430_SWI2CMST_repeatedStart();				//Send I2C Repeated Start Condition
}

// Ende MCP4726.c
