/*
 * MCP4726.h
 *
 *  Created on: 14.03.2013
 *      Author: DL9MWE
 */

#ifndef MCP4726_H_
#define MCP4726_H_

#define	MAX_DAC_VALUE	4096	// maximaler Eingabe-Wert fr 12-Bit DAC


//		I2C-Interface zum MCP4726
//*************************************
// die Device-Adresse der MCP47x6-Chips besteht aus einem festen Wert (1100) als oberes Nibble und
//  einem Chip-spezifischen Code (A2 A1 A0) und dem Read/_Write Bit (Read = 1; Write = 0) als LSB
// A2=A1=A0 = 0 ist der Normalfall
#define A2A1A0			0x00				// der Normalfall...
#define	MCP4726_I2C_Address	0xC0 | A2A1A0	// MCP4726 Device Adresse



// 		MCP4726 commands
//***************************
#define	MCP4726_Write_Volatile_DAC_Register			0x00
#define	MCP4726_Write_Volatile_Memory				0x02
#define MCP4726_Write_All_Memory					0x03
#define MCP4726_Write_Volatile_Configuration_bits	0x04

#define MCP4726_REF_VOLTAGE		0x00 // Referenz ist VDD (Unbuffered)
#define MCP4726_POWER_DOWN		0x00 // Not Powered Down (Normal operation)


//		Prototypes
//********************
//sendet einen DAC-Wert via I2C. Endet mit Stop condition,
void MCP4726_setDAC_value(unsigned int value, unsigned int* error_code);

// sendet einen DAC-Wert via I2C. Endet mit repeated Start condition,
void MCP4726_continuousDAC_value(unsigned int value, unsigned int* error_code);


#endif /* MCP4726_H_ */
